#include "dialog.h"
#include "ui_dialog.h"

Dialog::Dialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Dialog)
{
    ui->setupUi(this);
}

Dialog::~Dialog()
{
    m_cThread.WaitThread();
    delete ui;
}

void Dialog::on_pushButton_clicked()
{
    ON_MESSAGE_POST(m_cThread, SIGNAL(WM_MESSAGE(int,int)), SLOT(OnMessage(int,int)));
    m_cThread.BeginThread(Dialog::THREAD_PROC, this);
}

void Dialog::THREAD_PROC(void* pContext)
{
    int i = 0;

    for (i=0; i<5; i++)
    {
        INFOLOG("[THREAD] Try to Signal Emit : %d", i);
		
        // emit을 하게되면 UI Primary Thread로 호출되지 않을 수 있다.
        // 그래서, QMetaObject::invokeMethod(...)를 이용해야 한다.
        // emit ((Dialog*)pContext)->WM_MESSAGE(i, i+i);
		QMetaObject::invokeMethod((Dialog*)pContext, "WM_MESSAGE", Qt::BlockingQueuedConnection, Q_ARG(int, i), Q_ARG(int, i+1));
		
        sleep(1);
    }
}

void Dialog::OnMessage(int nIndex, int nValue)
{
    INFOLOG("[HANDLER] Thread Msg Signal Emitted, i=%d, i+i=%d", nIndex, nValue);
    sleep(2);
}
